#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
typedef pair<int, int> pii;

const int MAXN = 100000;
int N;
pii A[MAXN];

void read()
{
    cin >> N;
    for (int i = 0; i < N; i++)
    {
        cin >> A[i].first >> A[i].second;
        if (A[i].first > A[i].second)
            swap(A[i].first, A[i].second);
    }
}

vector<int> answer;

bool have_edge(int i, int j)
{
    if (i == j)
        return true;
    if (i > j)
        swap(i, j);
    for (int i1 = 0; i1 < N; i1++)
        if (A[i1] == make_pair(i, j))
            return true;
    return false;
}

void init(int i, int j)
{
    for (int team = 1; team <= N; team++)
    {
        if ((team == i) || (team == j))
            continue;
        bool found = true;
        for (const auto &it : answer)
            if (have_edge(it, team))
            {
                found = false;
                break;
            }
        if (found)
            answer.push_back(team);
    }
}

vector<int> output;

void solve_slow()
{
    int max_len = 0;
    answer.clear();
    for (int i = 1; i <= N; i++)
        for (int j = 1; j <= N; j++)
            if (!have_edge(i, j))
            {
                answer.push_back(i);
                answer.push_back(j);
                init(i, j);
                if ((int)answer.size() > max_len)
                {
                    max_len = (int)answer.size();
                    output = answer;
                }
                answer.clear();
            }
    cout << max_len << endl;
    for (const auto &it : output)
        cout << it << ' ';
    cout << endl;
}

bool pii_sorter(const pii &x, const pii &y)
{
    if (x.first == y.first)
        return x.second <= y.second;
    return x.first < y.first;
}

void solve()
{
    sort(A, A + N, pii_sorter);
    solve_slow();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();
    solve();

    return EXIT_SUCCESS;
}

